searchNodes=[{"ref":"BtrzExApiClient.html","title":"BtrzExApiClient","type":"module","doc":"Main module to handle requests to the Betterez&#39;s APIs."},{"ref":"BtrzExApiClient.html#request/6","title":"BtrzExApiClient.request/6","type":"function","doc":"This function will prepare and do the request through the HTTP client and will handle success and errors responses. headers :x_api_key - Optional. This value will be placed in the x-api-key header. :internal - Optional. Boolean. If true it will use the main/secondary keys (passed via config) for getting an internal JWT to be set in the Authorization header. Defaults to false. :token - Optional. Set the JWT in the Authorization header. If :internal option is true, this option will be discarded. options Using the HTTPoison options (https://hexdocs.pm/httpoison/HTTPoison.Request.html)"},{"ref":"BtrzExApiClient.APIConnectionError.html","title":"BtrzExApiClient.APIConnectionError","type":"exception","doc":"Failure to connect to Betterez&#39;s API."},{"ref":"BtrzExApiClient.APIError.html","title":"BtrzExApiClient.APIError","type":"exception","doc":"API errors cover any other type of problem (e.g., a temporary problem with Betterez&#39;s servers) and are extremely uncommon."},{"ref":"BtrzExApiClient.AuthenticationError.html","title":"BtrzExApiClient.AuthenticationError","type":"exception","doc":"Failure to properly authenticate yourself in the request."},{"ref":"BtrzExApiClient.InvalidRequestError.html","title":"BtrzExApiClient.InvalidRequestError","type":"exception","doc":"Invalid request errors arise when your request has invalid parameters."},{"ref":"BtrzExApiClient.Types.html","title":"BtrzExApiClient.Types","type":"module","doc":"BtrzExApiClient types."},{"ref":"BtrzExApiClient.Types.html#t:error/0","title":"BtrzExApiClient.Types.error/0","type":"type","doc":"The default error tuple."},{"ref":"BtrzExApiClient.Types.html#t:headers/0","title":"BtrzExApiClient.Types.headers/0","type":"type","doc":"HTTP headers. Headers are sent and received as lists of two-element tuples containing two strings, the header name and header value."},{"ref":"BtrzExApiClient.Types.html#t:methods/0","title":"BtrzExApiClient.Types.methods/0","type":"type","doc":"The allowed HTTP methods. Methods are defined as atoms."},{"ref":"BtrzExApiClient.Accounts.Account.html","title":"BtrzExApiClient.Accounts.Account","type":"module","doc":"Available Account endpoints in btrz-api-accounts."},{"ref":"BtrzExApiClient.Accounts.Account.html#path/0","title":"BtrzExApiClient.Accounts.Account.path/0","type":"function","doc":""},{"ref":"BtrzExApiClient.Accounts.Account.html#retrieve/3","title":"BtrzExApiClient.Accounts.Account.retrieve/3","type":"function","doc":"Retrive a(n) Account by its ID"},{"ref":"BtrzExApiClient.Accounts.Lexicon.html","title":"BtrzExApiClient.Accounts.Lexicon","type":"module","doc":"Available Lexicon endpoints in btrz-api-accounts."},{"ref":"BtrzExApiClient.Accounts.Lexicon.html#buscompany/2","title":"BtrzExApiClient.Accounts.Lexicon.buscompany/2","type":"function","doc":""},{"ref":"BtrzExApiClient.Accounts.Lexicon.html#buscompany_path/0","title":"BtrzExApiClient.Accounts.Lexicon.buscompany_path/0","type":"function","doc":""},{"ref":"BtrzExApiClient.Accounts.Lexicon.html#create/3","title":"BtrzExApiClient.Accounts.Lexicon.create/3","type":"function","doc":"Create a(n) Lexicon"},{"ref":"BtrzExApiClient.Accounts.Lexicon.html#path/0","title":"BtrzExApiClient.Accounts.Lexicon.path/0","type":"function","doc":""},{"ref":"BtrzExApiClient.Accounts.Permission.html","title":"BtrzExApiClient.Accounts.Permission","type":"module","doc":"Available Permission endpoints in btrz-api-accounts."},{"ref":"BtrzExApiClient.Accounts.Permission.html#import/3","title":"BtrzExApiClient.Accounts.Permission.import/3","type":"function","doc":""},{"ref":"BtrzExApiClient.Accounts.Permission.html#import_path/0","title":"BtrzExApiClient.Accounts.Permission.import_path/0","type":"function","doc":""},{"ref":"BtrzExApiClient.Accounts.Permission.html#list/3","title":"BtrzExApiClient.Accounts.Permission.list/3","type":"function","doc":"List all Permissions"},{"ref":"BtrzExApiClient.Accounts.Permission.html#path/0","title":"BtrzExApiClient.Accounts.Permission.path/0","type":"function","doc":""},{"ref":"BtrzExApiClient.Accounts.Role.html","title":"BtrzExApiClient.Accounts.Role","type":"module","doc":"Available Role endpoints in btrz-api-accounts."},{"ref":"BtrzExApiClient.Accounts.Role.html#import/3","title":"BtrzExApiClient.Accounts.Role.import/3","type":"function","doc":""},{"ref":"BtrzExApiClient.Accounts.Role.html#import_path/0","title":"BtrzExApiClient.Accounts.Role.import_path/0","type":"function","doc":""},{"ref":"BtrzExApiClient.Accounts.Role.html#list/3","title":"BtrzExApiClient.Accounts.Role.list/3","type":"function","doc":"List all Roles"},{"ref":"BtrzExApiClient.Accounts.Role.html#path/0","title":"BtrzExApiClient.Accounts.Role.path/0","type":"function","doc":""},{"ref":"BtrzExApiClient.Accounts.User.html","title":"BtrzExApiClient.Accounts.User","type":"module","doc":"Available User endpoints in btrz-api-accounts."},{"ref":"BtrzExApiClient.Accounts.User.html#import/3","title":"BtrzExApiClient.Accounts.User.import/3","type":"function","doc":""},{"ref":"BtrzExApiClient.Accounts.User.html#import_path/0","title":"BtrzExApiClient.Accounts.User.import_path/0","type":"function","doc":""},{"ref":"BtrzExApiClient.Accounts.User.html#list/3","title":"BtrzExApiClient.Accounts.User.list/3","type":"function","doc":"List all Users"},{"ref":"BtrzExApiClient.Accounts.User.html#path/0","title":"BtrzExApiClient.Accounts.User.path/0","type":"function","doc":""},{"ref":"BtrzExApiClient.Inventory.Station.html","title":"BtrzExApiClient.Inventory.Station","type":"module","doc":"Available Station endpoints in btrz-api-inventory."},{"ref":"BtrzExApiClient.Inventory.Station.html#import/3","title":"BtrzExApiClient.Inventory.Station.import/3","type":"function","doc":""},{"ref":"BtrzExApiClient.Inventory.Station.html#import_path/0","title":"BtrzExApiClient.Inventory.Station.import_path/0","type":"function","doc":""},{"ref":"BtrzExApiClient.Inventory.Station.html#list/3","title":"BtrzExApiClient.Inventory.Station.list/3","type":"function","doc":"List all Stations"},{"ref":"BtrzExApiClient.Inventory.Station.html#path/0","title":"BtrzExApiClient.Inventory.Station.path/0","type":"function","doc":""},{"ref":"BtrzExApiClient.Operations.Ticket.html","title":"BtrzExApiClient.Operations.Ticket","type":"module","doc":"Available Ticket endpoints in btrz-api-operations."},{"ref":"BtrzExApiClient.Operations.Ticket.html#path/0","title":"BtrzExApiClient.Operations.Ticket.path/0","type":"function","doc":""},{"ref":"BtrzExApiClient.Operations.Ticket.html#retrieve/3","title":"BtrzExApiClient.Operations.Ticket.retrieve/3","type":"function","doc":"Retrive a(n) Ticket by its ID"},{"ref":"BtrzExApiClient.Operations.Transaction.html","title":"BtrzExApiClient.Operations.Transaction","type":"module","doc":"Available Transaction endpoints in btrz-api-operations."},{"ref":"BtrzExApiClient.Operations.Transaction.html#path/0","title":"BtrzExApiClient.Operations.Transaction.path/0","type":"function","doc":""},{"ref":"BtrzExApiClient.Operations.Transaction.html#retrieve/3","title":"BtrzExApiClient.Operations.Transaction.retrieve/3","type":"function","doc":"Retrive a(n) Transaction by its ID"},{"ref":"BtrzExApiClient.Webhooks.Subscription.html","title":"BtrzExApiClient.Webhooks.Subscription","type":"module","doc":"Available Subscription endpoints in btrz-api-webhooks."},{"ref":"BtrzExApiClient.Webhooks.Subscription.html#list/3","title":"BtrzExApiClient.Webhooks.Subscription.list/3","type":"function","doc":"List all Subscriptions"},{"ref":"BtrzExApiClient.Webhooks.Subscription.html#path/0","title":"BtrzExApiClient.Webhooks.Subscription.path/0","type":"function","doc":""},{"ref":"BtrzExApiClient.Webhooks.Undelivered.html","title":"BtrzExApiClient.Webhooks.Undelivered","type":"module","doc":"Available Undelivered endpoints in btrz-api-webhooks."},{"ref":"BtrzExApiClient.Webhooks.Undelivered.html#create/3","title":"BtrzExApiClient.Webhooks.Undelivered.create/3","type":"function","doc":"Create a(n) Undelivered"},{"ref":"BtrzExApiClient.Webhooks.Undelivered.html#path/0","title":"BtrzExApiClient.Webhooks.Undelivered.path/0","type":"function","doc":""},{"ref":"readme.html","title":"BtrzExApiClient","type":"extras","doc":"BtrzExApiClient Elixir Betterez&#39;s APIs client."},{"ref":"readme.html#documentation","title":"BtrzExApiClient - Documentation","type":"extras","doc":"API documentation at HexDocs https://hexdocs.pm/btrz_ex_api_client"},{"ref":"readme.html#installation","title":"BtrzExApiClient - Installation","type":"extras","doc":"def deps do [{:btrz_ex_api_client, &quot;~&gt; 0.6.0&quot;}] end"},{"ref":"readme.html#configuration","title":"BtrzExApiClient - Configuration","type":"extras","doc":"Add the services base endpoints (mandatory) config :btrz_ex_api_client, :services, accounts: &quot;http://localhost:3050/accounts/&quot;, webhooks: &quot;http://localhost:4000/webhooks/&quot; # ... etc If you will need the Betterez internal JWT (inter-application auth) you have provide your secret keys in your config file (it&#39;s optional depending you will use internal token) config :btrz_ex_api_client, :internal_token, main_secret: &quot;A_SECRET_KEY&quot;, secondary_secret: &quot;A_SECRET_KEY&quot;"},{"ref":"readme.html#basic-usage","title":"BtrzExApiClient - Basic usage","type":"extras","doc":"Depending your resource, it will implement the basic CRUD actions and will be invoked as follows: BtrzExApiClient.{RESOURCE}.create/2 (POST) BtrzExApiClient.{RESOURCE}.retrieve/2 (GET) BtrzExApiClient.{RESOURCE}.update/3 (PUT) BtrzExApiClient.{RESOURCE}.list/2 (GET) BtrzExApiClient.{RESOURCE}.delete/3 (DELETE) The endpoints will return {:ok, response} or {:error, ERROR_STRUCT}, depending the case."},{"ref":"readme.html#posible-errors","title":"BtrzExApiClient - Posible errors","type":"extras","doc":"%APIConnectionError{} - Failure to connect to Betterez&#39;s API. %AuthenticationError{} - Failure to properly authenticate yourself in the request. %InvalidRequestError{} - Invalid request errors arise when your request has invalid parameters. %APIError{} - Other generic errors"},{"ref":"readme.html#adding-new-endpoints","title":"BtrzExApiClient - Adding new endpoints","type":"extras","doc":"Please be careful with the folder structure, this example is under lib/btrz_ex_api_client/accounts/ The use BtrzExApiClient.API macro will receive a list of :atoms of the pre-defined actions desired. defmodule BtrzExApiClient.Accounts.User do use BtrzExApiClient.API, [:list, :create, :retrieve, :delete, :update] def path do Application.get_env(:btrz_ex_api_client, :services)[:accounts] &lt;&gt; &quot;users&quot; end end You might want to add custom routes, i.e: a POST accounts/users/import: defmodule BtrzExApiClient.Accounts.User do use BtrzExApiClient.API, [:list, :create, :retrieve, :delete, :update] def path do Application.get_env(:btrz_ex_api_client, :services)[:accounts] &lt;&gt; &quot;users&quot; end def import_path() do path() &lt;&gt; &quot;/import&quot; end def import(data, opts \\\\ []) do BtrzExApiClient.request(:post, import_path(), [], data, opts) end end"},{"ref":"readme.html#betterez-auth","title":"BtrzExApiClient - Betterez Auth","type":"extras","doc":"Betterez API&#39;s use the x-api-key and Authorization headers, depending the endpoint, they can be sent via the opts param: BtrzExApiClient.Accounts.User.list([x_api_key: my_x_api_key]) - will add the x-api-key header. BtrzExApiClient.Accounts.User.list([x_api_key: my_x_api_key, internal: true]) - will request an internal token to the Betterez provider using the config keys and will add it to the Authorization header (using the Bearer JWT). BtrzExApiClient.Accounts.User.list([x_api_key: x_api_key, token: my_token]) - will add the user token to the Authorization header (using the Bearer JWT)."}]